Lua_FirstRechargeHeroOnePanel = class("Lua_FirstRechargeHeroOnePanel", Lua_ListCell);
function Lua_FirstRechargeHeroOnePanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FirstRechargeHeroOnePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showItemArr = Array();

	self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "default", 0, 0, 720, 768);
	self.bg.alpha = 0.01;
	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);
end

function Lua_FirstRechargeHeroOnePanel:setData(data)
	if data == nil then
		return;
	end

	local gradeInfo = DataCenter.firstRechargeData:getGradeInfo(data);
	local heroIdDic = gradeInfo.heroIdList;
	local arr = self.showItemArr;
	local maxLen = arr:getSize() > #heroIdDic and arr:getSize() or #heroIdDic;
	local item;
	for i = 1, maxLen do
		item = arr[i];
		if item == nil then
			item = Lua_FirstRechargeHeroOneItem.new(self.content);
			item.contentName = "Lua_FirstRechargeHeroOneItem_" .. i;
			arr:add(item);
		end
		item:stopPlayEff();
		item:setEnable(false);
		item:setLocation(0, 0, 0);
		
		if i <= #heroIdDic then
			item:setData({gradeInfo = gradeInfo, index = i});
		end
	end
end

function Lua_FirstRechargeHeroOnePanel:onBgClick(go)
end

function Lua_FirstRechargeHeroOnePanel:dispose()
	if self.starInfoArr ~= nil then
		self.starInfoArr:dispose();
		self.starInfoArr:clear();
		self.starInfoArr = nil;
	end
	self:superCall("dispose");
end










Lua_FirstRechargeHeroOneItem = class("Lua_FirstRechargeHeroOneItem", Lua_DisplayObject);
function Lua_FirstRechargeHeroOneItem:ctor(p)
	self:superCall("ctor", p, "FirstRechargeHeroItem_skin");
end

function Lua_FirstRechargeHeroOneItem:buildShowItem()
	self:superCall("buildShowItem");
	self.heroInfoIcon:addClickFuntion(self, self.onheroClick);
end

function Lua_FirstRechargeHeroOneItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.gradeInfo = data.gradeInfo;
	self.isFirst = true;
	self.showStep = 1;
	self.showTweenStep = 1;

	if self.gradeInfo.isPlayTween then -- 播放动画
		self.heroImg:removeLoadCompleteFun(self, self.onLoadCompletedFun);
		self:setImgInfo(self.showStep);
		self:startPlayEff();
	else
		self.heroImg:addLoadCompleteFun(self, self.onLoadCompletedFun);
		self:setImgInfo(self.showStep);
	end
end

function Lua_FirstRechargeHeroOneItem:setImgInfo(step)
	local imgInfo = self.gradeInfo:getHeroImgInfo(self._data.index, step);
	local imgPos = self.gradeInfo:getHeroImgPosInfo(self._data.index, step);
	self.heroImg:SetDimensions(0, 0);
	self.heroImg:setUrl(nil);
	self.heroImg:setUrl(self.gradeInfo.heroUrl .. imgInfo);
	self.heroImg:setLocation(imgPos[1], imgPos[2]);

	local sprite = self.gradeInfo:getHeroDetailInfoSprite(self._data.index, step);
	local detailPos = self.gradeInfo:getHeroDetailPosInfo(self._data.index, step);
	local readPos = self.gradeInfo:getHeroReadPosInfo(self._data.index, step);
	self.heroInfoIcon:setAltas(self.gradeInfo.atlas, sprite);
	self.heroInfoIcon:setLocation(detailPos[1], detailPos[2]);
	self.heroReadBtn:setLocation(readPos[1], readPos[2]);
end

function Lua_FirstRechargeHeroOneItem:startPlayEff()
	local moveInfoDic = self.gradeInfo:getShowHeroInfo(self._data.index, self.showStep, self.showTweenStep);
	if moveInfoDic == nil then
		return;
	end

	local posX;
	local posY;
	if moveInfoDic[1] == 1 then -- 左 → 右
		posX = moveInfoDic[2];
		posY = self.y;
	elseif moveInfoDic[1] == 2 then -- 右 → 左
		posX = moveInfoDic[2];
		posY = self.y;
	elseif moveInfoDic[1] == 3 then -- 下 → 上
		posX = self.x;
		posY = moveInfoDic[2];
	else
		posX = self.x;
		posY = self.y;
	end
	-- print(self._data.index, self.showStep, self.showTweenStep, posX, posY);

	-- 开始播放，0.8秒暂停
	local firstTime = self.isFirst and 0.1 or 0.8;
	self.isFirst = false;
	TweenUtil.getInstance():addTweenTargetPos(self.mainContent, firstTime, 0, posX, posY, 0, self, self.movePlayEff);
end

-- 移动
function Lua_FirstRechargeHeroOneItem:movePlayEff()
	self.mainContent:SetActive(true);
	TweenUtil.getInstance():addTweenTargetPos(self.mainContent, 1, 0, self.x, self.y, 0, self, self.overPlayEff);
end

function Lua_FirstRechargeHeroOneItem:overPlayEff()
	self:setImgInfo(self.showStep);

	local showInfoDic = self.gradeInfo:getShowHeroInfo(self._data.index, self.showStep, self.showTweenStep + 1);
	if showInfoDic ~= nil then
		self.showTweenStep = self.showTweenStep + 1;
		self:startPlayEff();
	else
		local stepInfoDic = self.gradeInfo:getTweenInfo(self._data.index);
		self.showTweenStep = 1;
		if stepInfoDic[self.showStep + 1] ~= nil then
			TweenUtil.getInstance():addTweenTargetAlpha(self.mainContent, 0.6, 0, -1, true, self, self.endAlhpaFun);
			self.showStep = self.showStep + 1;
			self:startPlayEff();
		else
			if self.gradeInfo.isLoop then
				TweenUtil.getInstance():addTweenTargetAlpha(self.mainContent, 0.6, 0, -1, true, self, self.endAlhpaFun);
				self.showStep = 1;
				self.showTweenStep = 1;
				self:startPlayEff();
			else
				self:stopPlayEff();
			end
		end
	end
end

function Lua_FirstRechargeHeroOneItem:endAlhpaFun()
	self:setImgInfo(self.showStep);
end

function Lua_FirstRechargeHeroOneItem:stopPlayEff()
	TweenUtil.getInstance():stop(self.mainContent);
end

function Lua_FirstRechargeHeroOneItem:onLoadCompletedFun()
	self.mainContent:SetActive(true);
end

function Lua_FirstRechargeHeroOneItem:onheroClick(go)
	local heroIdDic = self.gradeInfo.heroIdList[self._data.index];
	DataCenter.heroAtlasData:onOpenAtlasWindow(heroIdDic[self.showStep]);
end

function Lua_FirstRechargeHeroOneItem:dispose()
	self.gradeInfo = nil;
	self._data = nil;
	self:stopPlayEff();
	self:superCall("dispose");
end